(function (_, kotlin_clikt_clikt, kotlin_kotlin, kotlin_mordant_mordant) {
  'use strict';
  //region block: imports
  var CoreCliktCommand = kotlin_clikt_clikt.$_$.a;
  var VOID = kotlin_kotlin.$_$.g;
  var Unit_instance = kotlin_kotlin.$_$.h3;
  var protoOf = kotlin_kotlin.$_$.p8;
  var initMetadataForClass = kotlin_kotlin.$_$.q7;
  var selfAndAncestors = kotlin_clikt_clikt.$_$.e;
  var mapNotNull = kotlin_kotlin.$_$.p9;
  var firstOrNull = kotlin_kotlin.$_$.k9;
  var Terminal_init_$Create$ = kotlin_mordant_mordant.$_$.g;
  var last = kotlin_kotlin.$_$.o9;
  var MultiplatformSystem_instance = kotlin_mordant_mordant.$_$.i;
  var FileNotFound = kotlin_clikt_clikt.$_$.b;
  var Terminal = kotlin_mordant_mordant.$_$.b;
  var Whitespace_NORMAL_getInstance = kotlin_mordant_mordant.$_$.e;
  var Text_init_$Create$ = kotlin_mordant_mordant.$_$.h;
  var AbstractHelpFormatter = kotlin_clikt_clikt.$_$.g;
  var verticalLayout = kotlin_mordant_mordant.$_$.a;
  var charSequenceLength = kotlin_kotlin.$_$.g7;
  var definitionList = kotlin_mordant_mordant.$_$.c;
  var withPadding = kotlin_mordant_mordant.$_$.d;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.e4;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.k;
  var ensureNotNull = kotlin_kotlin.$_$.nc;
  var drop = kotlin_kotlin.$_$.aa;
  var plus = kotlin_kotlin.$_$.tc;
  var Whitespace_PRE_WRAP_getInstance = kotlin_mordant_mordant.$_$.f;
  var isBlank = kotlin_kotlin.$_$.ha;
  var replace = kotlin_kotlin.$_$.ta;
  //endregion
  //region block: pre-declaration
  initMetadataForClass(CliktCommand, 'CliktCommand', VOID, CoreCliktCommand);
  initMetadataForClass(MordantHelpFormatter, 'MordantHelpFormatter', VOID, AbstractHelpFormatter);
  //endregion
  function CliktCommand(name) {
    name = name === VOID ? null : name;
    CoreCliktCommand.call(this, name);
    installMordant(this);
  }
  function installMordant(_this__u8e3s4, force) {
    force = force === VOID ? false : force;
    _this__u8e3s4.t1h(installMordant$lambda(force));
  }
  function get_terminal(_this__u8e3s4) {
    // Inline function 'com.github.ajalt.clikt.core.Context.findObject' call
    var key = 'mordant_terminal';
    var tmp = selfAndAncestors(_this__u8e3s4);
    var tmp0_elvis_lhs = firstOrNull(mapNotNull(tmp, _get_terminal_$lambda_5keric(key)));
    var tmp_0;
    if (tmp0_elvis_lhs == null) {
      // Inline function 'kotlin.also' call
      var this_0 = Terminal_init_$Create$();
      // Inline function 'kotlin.contracts.contract' call
      // Inline function 'com.github.ajalt.clikt.core.<get-terminal>.<anonymous>' call
      // Inline function 'kotlin.collections.set' call
      var this_1 = last(selfAndAncestors(_this__u8e3s4)).r1f_1;
      var key_0 = 'mordant_terminal';
      this_1.e2(key_0, this_0);
      tmp_0 = this_0;
    } else {
      tmp_0 = tmp0_elvis_lhs;
    }
    return tmp_0;
  }
  function installMordant$lambda$lambda(it) {
    return new MordantHelpFormatter(it);
  }
  function installMordant$lambda$lambda_0(it) {
    return MultiplatformSystem_instance.o23(it);
  }
  function installMordant$lambda$lambda_1(it) {
    var tmp0_elvis_lhs = MultiplatformSystem_instance.q23(it);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      throw new FileNotFound(it);
    } else {
      tmp = tmp0_elvis_lhs;
    }
    return tmp;
  }
  function installMordant$lambda$lambda_2(it) {
    MultiplatformSystem_instance.p23(it);
    return Unit_instance;
  }
  function installMordant$lambda$lambda_3(context, message, trailingNewline, err) {
    if (trailingNewline) {
      get_terminal(context).p2d(message, VOID, VOID, VOID, VOID, err);
    } else {
      get_terminal(context).n2d(message, VOID, VOID, VOID, VOID, err);
    }
    return Unit_instance;
  }
  function installMordant$lambda($force) {
    return function ($this$configureContext) {
      var tmp;
      if (!$force && !($this$configureContext.u1h_1 == null)) {
        return Unit_instance;
      }
      var tmp_0 = $this$configureContext;
      tmp_0.z1h_1 = installMordant$lambda$lambda;
      var tmp_1 = $this$configureContext;
      tmp_1.h1i_1 = installMordant$lambda$lambda_0;
      var tmp_2 = $this$configureContext;
      tmp_2.c1i_1 = installMordant$lambda$lambda_1;
      var tmp_3 = $this$configureContext;
      tmp_3.k1i_1 = installMordant$lambda$lambda_2;
      var tmp_4 = $this$configureContext;
      tmp_4.j1i_1 = installMordant$lambda$lambda_3;
      return Unit_instance;
    };
  }
  function _get_terminal_$lambda_5keric($key) {
    return function (it) {
      var tmp = it.r1f_1.w1($key);
      return tmp instanceof Terminal ? tmp : null;
    };
  }
  function MordantHelpFormatter$formatHelp$lambda(this$0, $error, $prolog, $epilog, $parameters, $programName) {
    return function ($this$verticalLayout) {
      $this$verticalLayout.f2a(1);
      $this$verticalLayout.c2a(this$0.c1o($error, $prolog, $epilog, $parameters, $programName));
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderUsage$lambda($prog, $usageParts) {
    return function ($this$definitionList) {
      $this$definitionList.z2d($prog, Text_init_$Create$($usageParts, Whitespace_NORMAL_getInstance()));
      $this$definitionList.t2d_1 = true;
      $this$definitionList.w2d(1);
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderProlog$lambda($this$withPadding) {
    $this$withPadding.c2c_1 = 2;
    return Unit_instance;
  }
  function MordantHelpFormatter$renderParameters$lambda(this$0, $parameters) {
    return function ($this$definitionList) {
      var _iterator__ex2g4s = this$0.p1p($parameters).m();
      while (_iterator__ex2g4s.n()) {
        var section = _iterator__ex2g4s.o();
        $this$definitionList.z2d(section.j1n_1, section.k1n_1);
      }
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderOptionGroup$lambda($this$withPadding) {
    $this$withPadding.z2b_1 = 1;
    $this$withPadding.c2c_1 = 2;
    $this$withPadding.b2c_1 = 1;
    return Unit_instance;
  }
  function MordantHelpFormatter$renderOptionGroup$lambda_0($markdown, this$0, $options) {
    return function ($this$verticalLayout) {
      $this$verticalLayout.e2a($markdown);
      $this$verticalLayout.e2a(this$0.z1p($options));
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$buildParameterList$lambda($rows, this$0) {
    return function ($this$definitionList) {
      $this$definitionList.t2d_1 = true;
      var _iterator__ex2g4s = $rows.m();
      while (_iterator__ex2g4s.n()) {
        var row = _iterator__ex2g4s.o();
        $this$definitionList.a2e(this$0.u1q(row), this$0.v1q(row));
      }
      return Unit_instance;
    };
  }
  function MordantHelpFormatter(context, requiredOptionMarker, showDefaultValues, showRequiredTag) {
    requiredOptionMarker = requiredOptionMarker === VOID ? null : requiredOptionMarker;
    showDefaultValues = showDefaultValues === VOID ? false : showDefaultValues;
    showRequiredTag = showRequiredTag === VOID ? false : showRequiredTag;
    AbstractHelpFormatter.call(this, context, requiredOptionMarker, showDefaultValues, showRequiredTag);
  }
  protoOf(MordantHelpFormatter).e2f = function () {
    return get_terminal(this.q1n_1).z26_1;
  };
  protoOf(MordantHelpFormatter).n1h = function (error, prolog, epilog, parameters, programName) {
    var widget = verticalLayout(MordantHelpFormatter$formatHelp$lambda(this, error, prolog, epilog, parameters, programName));
    return get_terminal(this.q1n_1).q2d(widget);
  };
  protoOf(MordantHelpFormatter).e1o = function (parameters, error) {
    return Text_init_$Create$(this.i1o(parameters, error));
  };
  protoOf(MordantHelpFormatter).d1o = function (parameters, programName) {
    var title = this.f2f(this.b1o().p1q());
    var prog = title + ' ' + programName;
    var usageParts = this.m1o(parameters);
    var tmp;
    // Inline function 'kotlin.text.isEmpty' call
    if (charSequenceLength(usageParts) === 0) {
      tmp = Text_init_$Create$(prog, Whitespace_NORMAL_getInstance());
    } else {
      tmp = definitionList(MordantHelpFormatter$renderUsage$lambda(prog, usageParts));
    }
    return tmp;
  };
  protoOf(MordantHelpFormatter).f1o = function (prolog) {
    var tmp = this.g2f(prolog);
    return withPadding(tmp, false, MordantHelpFormatter$renderProlog$lambda);
  };
  protoOf(MordantHelpFormatter).h1o = function (epilog) {
    return this.g2f(epilog);
  };
  protoOf(MordantHelpFormatter).g1o = function (parameters) {
    return definitionList(MordantHelpFormatter$renderParameters$lambda(this, parameters));
  };
  protoOf(MordantHelpFormatter).n1p = function (help, parameters) {
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(parameters, 10));
    var tmp0_iterator = parameters.m();
    while (tmp0_iterator.n()) {
      var item = tmp0_iterator.o();
      var tmp$ret$0 = this.s1p(item);
      destination.e(tmp$ret$0);
    }
    var options = destination;
    if (help == null)
      return this.z1p(options);
    var tmp = this.g2f(help);
    var markdown = withPadding(tmp, false, MordantHelpFormatter$renderOptionGroup$lambda);
    return verticalLayout(MordantHelpFormatter$renderOptionGroup$lambda_0(markdown, this, options));
  };
  protoOf(MordantHelpFormatter).y1n = function (name) {
    // Inline function 'kotlin.text.lowercase' call
    // Inline function 'kotlin.js.asDynamic' call
    return '<' + name.toLowerCase() + '>';
  };
  protoOf(MordantHelpFormatter).x1p = function (name) {
    return this.e2f().o26('danger').m1z(name);
  };
  protoOf(MordantHelpFormatter).g1q = function (name) {
    return this.e2f().o26('muted').m1z(name);
  };
  protoOf(MordantHelpFormatter).w1n = function (name) {
    return this.e2f().o26('info').m1z(name);
  };
  protoOf(MordantHelpFormatter).z1n = function (name) {
    return this.e2f().o26('info').m1z(name);
  };
  protoOf(MordantHelpFormatter).a1o = function (name) {
    return this.e2f().o26('info').m1z(name);
  };
  protoOf(MordantHelpFormatter).o1p = function (title) {
    return this.e2f().o26('warning').m1z(title);
  };
  protoOf(MordantHelpFormatter).f2f = function (title) {
    return this.e2f().o26('warning').m1z(title);
  };
  protoOf(MordantHelpFormatter).k1o = function (title) {
    return this.e2f().o26('danger').m1z(title);
  };
  protoOf(MordantHelpFormatter).p1o = function (parameter) {
    return this.e2f().o26('muted').m1z(parameter);
  };
  protoOf(MordantHelpFormatter).i1q = function (metavar) {
    return this.e2f().o26('warning').b23(this.e2f().o26('muted')).m1z(metavar);
  };
  protoOf(MordantHelpFormatter).u1q = function (row) {
    var tmp;
    // Inline function 'kotlin.text.isNullOrEmpty' call
    var this_0 = row.n1n_1;
    // Inline function 'kotlin.contracts.contract' call
    if (this_0 == null || charSequenceLength(this_0) === 0) {
      tmp = '  ';
    } else {
      // Inline function 'kotlin.text.ifEmpty' call
      var this_1 = drop('  ', ensureNotNull(row.n1n_1).length);
      // Inline function 'kotlin.contracts.contract' call
      var tmp_0;
      // Inline function 'kotlin.text.isEmpty' call
      if (charSequenceLength(this_1) === 0) {
        // Inline function 'com.github.ajalt.clikt.output.MordantHelpFormatter.renderDefinitionTerm.<anonymous>' call
        tmp_0 = ' ';
      } else {
        tmp_0 = this_1;
      }
      var tmp$ret$3 = tmp_0;
      tmp = plus(row.n1n_1, tmp$ret$3);
    }
    var termPrefix = tmp;
    return Text_init_$Create$(termPrefix + row.l1n_1, Whitespace_PRE_WRAP_getInstance());
  };
  protoOf(MordantHelpFormatter).v1q = function (row) {
    return isBlank(row.m1n_1) ? Text_init_$Create$('') : this.g2f(row.m1n_1);
  };
  protoOf(MordantHelpFormatter).z1p = function (rows) {
    return definitionList(MordantHelpFormatter$buildParameterList$lambda(rows, this));
  };
  protoOf(MordantHelpFormatter).g2f = function (text) {
    return Text_init_$Create$(replace(text, '\n\n', '\x85\x85'), Whitespace_NORMAL_getInstance());
  };
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = CliktCommand;
  //endregion
  return _;
}(module.exports, require('./clikt-clikt.js'), require('./kotlin-kotlin-stdlib.js'), require('./mordant-mordant.js')));

//# sourceMappingURL=clikt-clikt-mordant.js.map
