(function (_, kotlin_kotlin) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var log2 = Math.log2;
  var protoOf = kotlin_kotlin.$_$.p8;
  var initMetadataForInterface = kotlin_kotlin.$_$.t7;
  var toString = kotlin_kotlin.$_$.r8;
  var IllegalArgumentException_init_$Create$ = kotlin_kotlin.$_$.d1;
  var initMetadataForClass = kotlin_kotlin.$_$.q7;
  var getStringHashCode = kotlin_kotlin.$_$.o7;
  var THROW_CCE = kotlin_kotlin.$_$.yb;
  var initMetadataForObject = kotlin_kotlin.$_$.v7;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.l;
  var charSequenceLength = kotlin_kotlin.$_$.g7;
  var charSequenceGet = kotlin_kotlin.$_$.f7;
  var toString_0 = kotlin_kotlin.$_$.s1;
  var Unit_instance = kotlin_kotlin.$_$.h3;
  var _Char___init__impl__6a9atx = kotlin_kotlin.$_$.p1;
  var arrayConcat = kotlin_kotlin.$_$.a;
  var listOf = kotlin_kotlin.$_$.h5;
  var withSign = kotlin_kotlin.$_$.t8;
  var trimMargin = kotlin_kotlin.$_$.hb;
  var hashCode = kotlin_kotlin.$_$.p7;
  var equals = kotlin_kotlin.$_$.j7;
  var VOID = kotlin_kotlin.$_$.g;
  var initMetadataForCompanion = kotlin_kotlin.$_$.r7;
  var coerceAtLeast = kotlin_kotlin.$_$.u8;
  var getNumberHashCode = kotlin_kotlin.$_$.m7;
  var numberToDouble = kotlin_kotlin.$_$.l8;
  var roundToInt = kotlin_kotlin.$_$.s8;
  var coerceIn = kotlin_kotlin.$_$.y8;
  var Char = kotlin_kotlin.$_$.mb;
  var toInt = kotlin_kotlin.$_$.fb;
  var numberRangeToNumber = kotlin_kotlin.$_$.j8;
  var slice = kotlin_kotlin.$_$.va;
  var startsWith = kotlin_kotlin.$_$.xa;
  var isInterface = kotlin_kotlin.$_$.e8;
  var contentEquals = kotlin_kotlin.$_$.h4;
  var coerceAtLeast_0 = kotlin_kotlin.$_$.w8;
  var objectCreate = kotlin_kotlin.$_$.o8;
  //endregion
  //region block: pre-declaration
  function toXYZ() {
    return this.u1w().v1w();
  }
  initMetadataForInterface(Color, 'Color');
  initMetadataForClass(ColorComponentInfo, 'ColorComponentInfo');
  initMetadataForClass(WhitePoint, 'WhitePoint');
  initMetadataForObject(Illuminant, 'Illuminant');
  initMetadataForClass(Matrix, 'Matrix');
  initMetadataForCompanion(Companion);
  initMetadataForClass(Ansi16, 'Ansi16', VOID, VOID, [Color]);
  initMetadataForCompanion(Companion_0);
  initMetadataForClass(Ansi256, 'Ansi256', VOID, VOID, [Color]);
  initMetadataForCompanion(Companion_1);
  initMetadataForClass(HSV, 'HSV', VOID, VOID, [Color]);
  initMetadataForClass(ICtCp, 'ICtCp', VOID, VOID, [Color]);
  initMetadataForObject(PqNonlinearity, 'PqNonlinearity');
  initMetadataForClass(GammaTransferFunctions, 'GammaTransferFunctions');
  initMetadataForObject(LinearTransferFunctions, 'LinearTransferFunctions');
  function invoke$default(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 1.0 : alpha;
    return $super === VOID ? this.f1y(r, g, b, alpha) : $super.f1y.call(this, r, g, b, alpha);
  }
  function invoke(r, g, b, alpha) {
    return this.f1y(numberToDouble(r), numberToDouble(g), numberToDouble(b), numberToDouble(alpha));
  }
  function invoke$default_0(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 1.0 : alpha;
    return $super === VOID ? this.k1z(r, g, b, alpha) : invoke(r, g, b, alpha);
  }
  function from255(r, g, b, alpha) {
    return this.f1y(r / 255.0, g / 255.0, b / 255.0, alpha / 255.0);
  }
  function from255$default(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 255 : alpha;
    return $super === VOID ? this.l1z(r, g, b, alpha) : from255(r, g, b, alpha);
  }
  function invoke_0(hex) {
    var tmp = parseHex(validateHex(hex), 0);
    var tmp_0 = parseHex(hex, 1);
    var tmp_1 = parseHex(hex, 2);
    var tmp_2;
    // Inline function 'kotlin.let' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.RGBColorSpace.invoke.<anonymous>' call
    var it = get_hexLength(hex);
    if (it === 4 || it === 8) {
      tmp_2 = parseHex(hex, 3);
    } else {
      tmp_2 = 255;
    }
    return this.l1z(tmp, tmp_0, tmp_1, tmp_2);
  }
  initMetadataForInterface(RGBColorSpace, 'RGBColorSpace');
  initMetadataForCompanion(Companion_2, VOID, [RGBColorSpace]);
  initMetadataForClass(RGB, 'RGB', VOID, VOID, [Color]);
  initMetadataForObject(RGBColorSpaces, 'RGBColorSpaces');
  initMetadataForObject(SRGB, 'SRGB', VOID, VOID, [RGBColorSpace]);
  initMetadataForClass(RGBColorSpaceImpl, 'RGBColorSpaceImpl', VOID, VOID, [RGBColorSpace]);
  initMetadataForObject(SRGBTransferFunctions, 'SRGBTransferFunctions');
  initMetadataForObject(ACESccTransferFunctions, 'ACESccTransferFunctions');
  initMetadataForObject(ACEScctTransferFunctions, 'ACEScctTransferFunctions');
  initMetadataForObject(BT2020TransferFunctions, 'BT2020TransferFunctions');
  initMetadataForObject(BT709TransferFunctions, 'BT709TransferFunctions');
  initMetadataForObject(ROMMTransferFunctions, 'ROMMTransferFunctions');
  initMetadataForInterface(XYZColorSpace, 'XYZColorSpace');
  initMetadataForCompanion(Companion_3, VOID, [XYZColorSpace]);
  initMetadataForClass(XYZ, 'XYZ', VOID, VOID, [Color]);
  initMetadataForObject(XYZColorSpaces, 'XYZColorSpaces');
  initMetadataForClass(XYZColorSpaceImpl, 'XYZColorSpaceImpl', VOID, VOID, [XYZColorSpace]);
  initMetadataForClass(xyY, 'xyY');
  //endregion
  function Color() {
  }
  function ColorComponentInfo(name, isPolar, min, max) {
    this.b1x_1 = name;
    this.c1x_1 = isPolar;
    this.d1x_1 = min;
    this.e1x_1 = max;
    // Inline function 'kotlin.require' call
    // Inline function 'kotlin.contracts.contract' call
    if (!(this.d1x_1 <= this.e1x_1)) {
      // Inline function 'com.github.ajalt.colormath.ColorComponentInfo.<anonymous>' call
      var message = 'min must be less than or equal to max';
      throw IllegalArgumentException_init_$Create$(toString(message));
    }
  }
  function WhitePoint(name, chromaticity) {
    this.f1x_1 = name;
    this.g1x_1 = chromaticity;
  }
  protoOf(WhitePoint).toString = function () {
    return this.f1x_1;
  };
  protoOf(WhitePoint).hashCode = function () {
    var result = getStringHashCode(this.f1x_1);
    result = imul(result, 31) + this.g1x_1.hashCode() | 0;
    return result;
  };
  protoOf(WhitePoint).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof WhitePoint))
      return false;
    var tmp0_other_with_cast = other instanceof WhitePoint ? other : THROW_CCE();
    if (!(this.f1x_1 === tmp0_other_with_cast.f1x_1))
      return false;
    if (!this.g1x_1.equals(tmp0_other_with_cast.g1x_1))
      return false;
    return true;
  };
  function Illuminant() {
    Illuminant_instance = this;
    this.h1x_1 = new WhitePoint('A', xyY_init_$Create$(0.44758, 0.40745));
    this.i1x_1 = new WhitePoint('B', xyY_init_$Create$(0.34842, 0.35161));
    this.j1x_1 = new WhitePoint('C', xyY_init_$Create$(0.31006, 0.31616));
    this.k1x_1 = new WhitePoint('D50', xyY_init_$Create$(0.3457, 0.3585));
    this.l1x_1 = new WhitePoint('D55', xyY_init_$Create$(0.33243, 0.34744));
    this.m1x_1 = new WhitePoint('D65', xyY_init_$Create$(0.3127, 0.329));
    this.n1x_1 = new WhitePoint('D75', xyY_init_$Create$(0.29903, 0.31488));
    this.o1x_1 = new WhitePoint('E', xyY_init_$Create$(1.0 / 3.0, 1.0 / 3.0));
  }
  var Illuminant_instance;
  function Illuminant_getInstance() {
    if (Illuminant_instance == null)
      new Illuminant();
    return Illuminant_instance;
  }
  function get_alphaInfo() {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    return alphaInfo;
  }
  var alphaInfo;
  function zeroOneComponentInfo(name) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    // Inline function 'kotlin.collections.buildList' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'kotlin.collections.buildListInternal' call
    // Inline function 'kotlin.apply' call
    var this_0 = ArrayList_init_$Create$();
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.internal.zeroOneComponentInfo.<anonymous>' call
    // Inline function 'kotlin.text.mapTo' call
    var inductionVariable = 0;
    while (inductionVariable < charSequenceLength(name)) {
      var item = charSequenceGet(name, inductionVariable);
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'com.github.ajalt.colormath.internal.zeroOneComponentInfo.<anonymous>.<anonymous>' call
      var tmp$ret$0 = new ColorComponentInfo(toString_0(item), false, 0.0, 1.0);
      this_0.e(tmp$ret$0);
    }
    this_0.e(get_alphaInfo());
    return this_0.h5();
  }
  function polarComponentInfo(name, l, r) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    // Inline function 'kotlin.collections.buildList' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'kotlin.collections.buildListInternal' call
    // Inline function 'kotlin.apply' call
    var this_0 = ArrayList_init_$Create$();
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.internal.polarComponentInfo.<anonymous>' call
    // Inline function 'kotlin.text.mapTo' call
    var inductionVariable = 0;
    while (inductionVariable < charSequenceLength(name)) {
      var item = charSequenceGet(name, inductionVariable);
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'com.github.ajalt.colormath.internal.polarComponentInfo.<anonymous>.<anonymous>' call
      var tmp$ret$0 = new ColorComponentInfo(toString_0(item), item === _Char___init__impl__6a9atx(72), item === _Char___init__impl__6a9atx(72) ? 0.0 : l, item === _Char___init__impl__6a9atx(72) ? 360.0 : r);
      this_0.e(tmp$ret$0);
    }
    this_0.e(get_alphaInfo());
    return this_0.h5();
  }
  function componentInfoList(c) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    return listOf(arrayConcat([c, [get_alphaInfo()]]));
  }
  var properties_initialized_ColorSpaceUtils_kt_kskdoe;
  function _init_properties_ColorSpaceUtils_kt__cnwylg() {
    if (!properties_initialized_ColorSpaceUtils_kt_kskdoe) {
      properties_initialized_ColorSpaceUtils_kt_kskdoe = true;
      alphaInfo = new ColorComponentInfo('alpha', false, 0.0, 1.0);
    }
  }
  function get_CAT02_XYZ_TO_LMS() {
    _init_properties_Constants_kt__atb1ur();
    return CAT02_XYZ_TO_LMS;
  }
  var CAT02_XYZ_TO_LMS;
  function get_CAT02_LMS_TO_XYZ() {
    _init_properties_Constants_kt__atb1ur();
    return CAT02_LMS_TO_XYZ;
  }
  var CAT02_LMS_TO_XYZ;
  var properties_initialized_Constants_kt_w4w61t;
  function _init_properties_Constants_kt__atb1ur() {
    if (!properties_initialized_Constants_kt_w4w61t) {
      properties_initialized_Constants_kt_w4w61t = true;
      CAT02_XYZ_TO_LMS = _Matrix___init__impl__q3kp4w_0(+0.7328, +0.4296, -0.1624, -0.7036, +1.6975, +0.0061, +0.003, +0.0136, +0.9834);
      CAT02_LMS_TO_XYZ = inverse(get_CAT02_XYZ_TO_LMS());
    }
  }
  function spow(_this__u8e3s4, p) {
    return spow_0(_this__u8e3s4, p);
  }
  function normalizeDeg(_this__u8e3s4) {
    return (_this__u8e3s4 % 360.0 + 360.0) % 360.0;
  }
  function spow_0(_this__u8e3s4, p) {
    // Inline function 'kotlin.math.pow' call
    // Inline function 'kotlin.math.absoluteValue' call
    var this_0 = Math.abs(_this__u8e3s4);
    var tmp$ret$1 = Math.pow(this_0, p);
    return withSign(tmp$ret$1, _this__u8e3s4);
  }
  function normalizeDeg_0(_this__u8e3s4) {
    return (_this__u8e3s4 % 360.0 + 360.0) % 360.0;
  }
  function _Matrix___init__impl__q3kp4w(rowMajor) {
    return rowMajor;
  }
  function _Matrix___get_rowMajor__impl__vmgxkq($this) {
    return $this;
  }
  function _Matrix___init__impl__q3kp4w_0(v00, v10, v20, v01, v11, v21, v02, v12, v22) {
    // Inline function 'kotlin.floatArrayOf' call
    var tmp$ret$0 = new Float32Array([v00, v10, v20, v01, v11, v21, v02, v12, v22]);
    return _Matrix___init__impl__q3kp4w(tmp$ret$0);
  }
  function Matrix__copy_impl_kmkvzd($this) {
    // Inline function 'kotlin.collections.copyOf' call
    // Inline function 'kotlin.js.asDynamic' call
    var tmp$ret$1 = _Matrix___get_rowMajor__impl__vmgxkq($this).slice();
    return _Matrix___init__impl__q3kp4w(tmp$ret$1);
  }
  function Matrix__get_impl_xogbpk($this, x, y) {
    return _Matrix___get_rowMajor__impl__vmgxkq($this)[imul(y, 3) + x | 0];
  }
  function Matrix__set_impl_s2l54c($this, x, y, value) {
    _Matrix___get_rowMajor__impl__vmgxkq($this)[imul(y, 3) + x | 0] = value;
  }
  function Matrix__set_impl_s2l54c_0($this, x, y, value) {
    return Matrix__set_impl_s2l54c($this, x, y, value);
  }
  function Matrix__toString_impl_l0abk0($this) {
    return trimMargin('Mat3(\n        |   ' + Matrix__get_impl_xogbpk($this, 0, 0) + ', ' + Matrix__get_impl_xogbpk($this, 1, 0) + ', ' + Matrix__get_impl_xogbpk($this, 2, 0) + ', \n        |   ' + Matrix__get_impl_xogbpk($this, 0, 1) + ', ' + Matrix__get_impl_xogbpk($this, 1, 1) + ', ' + Matrix__get_impl_xogbpk($this, 2, 1) + ', \n        |   ' + Matrix__get_impl_xogbpk($this, 0, 2) + ', ' + Matrix__get_impl_xogbpk($this, 1, 2) + ', ' + Matrix__get_impl_xogbpk($this, 2, 2) + ', \n        |)\n        ');
  }
  function Matrix__hashCode_impl_s9ntm9($this) {
    return hashCode($this);
  }
  function Matrix__equals_impl_g5p8p9($this, other) {
    if (!(other instanceof Matrix))
      return false;
    var tmp0_other_with_cast = other instanceof Matrix ? other.p1x_1 : THROW_CCE();
    if (!equals($this, tmp0_other_with_cast))
      return false;
    return true;
  }
  function Matrix(rowMajor) {
    this.p1x_1 = rowMajor;
  }
  protoOf(Matrix).toString = function () {
    return Matrix__toString_impl_l0abk0(this.p1x_1);
  };
  protoOf(Matrix).hashCode = function () {
    return Matrix__hashCode_impl_s9ntm9(this.p1x_1);
  };
  protoOf(Matrix).equals = function (other) {
    return Matrix__equals_impl_g5p8p9(this.p1x_1, other);
  };
  function inverse(_this__u8e3s4, inPlace) {
    inPlace = inPlace === VOID ? false : inPlace;
    var a = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0);
    var b = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0);
    var c = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0);
    var d = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1);
    var e = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1);
    var f = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1);
    var g = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2);
    var h = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2);
    var i = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2);
    var A = e * i - h * f;
    var B = h * c - b * i;
    var C = b * f - e * c;
    var det = a * A + d * B + g * C;
    var out = inPlace ? _this__u8e3s4 : Matrix__copy_impl_kmkvzd(_this__u8e3s4);
    Matrix__set_impl_s2l54c_0(out, 0, 0, A / det);
    Matrix__set_impl_s2l54c_0(out, 0, 1, (g * f - d * i) / det);
    Matrix__set_impl_s2l54c_0(out, 0, 2, (d * h - g * e) / det);
    Matrix__set_impl_s2l54c_0(out, 1, 0, B / det);
    Matrix__set_impl_s2l54c_0(out, 1, 1, (a * i - g * c) / det);
    Matrix__set_impl_s2l54c_0(out, 1, 2, (g * b - a * h) / det);
    Matrix__set_impl_s2l54c_0(out, 2, 0, C / det);
    Matrix__set_impl_s2l54c_0(out, 2, 1, (d * c - a * f) / det);
    Matrix__set_impl_s2l54c_0(out, 2, 2, (a * e - d * b) / det);
    return out;
  }
  function scalarDiv(_this__u8e3s4, x, inPlace) {
    inPlace = inPlace === VOID ? false : inPlace;
    var out = _Matrix___get_rowMajor__impl__vmgxkq(inPlace ? _this__u8e3s4 : Matrix__copy_impl_kmkvzd(_this__u8e3s4));
    var inductionVariable = 0;
    var last = out.length - 1 | 0;
    if (inductionVariable <= last)
      do {
        var i = inductionVariable;
        inductionVariable = inductionVariable + 1 | 0;
        out[i] = out[i] / x;
      }
       while (inductionVariable <= last);
    return _Matrix___init__impl__q3kp4w(out);
  }
  function dot(_this__u8e3s4, other) {
    return _Matrix___init__impl__q3kp4w_0(dot$f(_this__u8e3s4, other, 0, 0), dot$f(_this__u8e3s4, other, 1, 0), dot$f(_this__u8e3s4, other, 2, 0), dot$f(_this__u8e3s4, other, 0, 1), dot$f(_this__u8e3s4, other, 1, 1), dot$f(_this__u8e3s4, other, 2, 1), dot$f(_this__u8e3s4, other, 0, 2), dot$f(_this__u8e3s4, other, 1, 2), dot$f(_this__u8e3s4, other, 2, 2));
  }
  function dotDiagonal(_this__u8e3s4, v0, v1, v2) {
    return _Matrix___init__impl__q3kp4w_0(Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0) * v2, Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1) * v2, Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2) * v2);
  }
  function _Vector___init__impl__y7x4qq(values) {
    return values;
  }
  function _Vector___get_values__impl__3gdbp5($this) {
    return $this;
  }
  function _Vector___init__impl__y7x4qq_0(v0, v1, v2) {
    // Inline function 'kotlin.floatArrayOf' call
    var tmp$ret$0 = new Float32Array([v0, v1, v2]);
    return _Vector___init__impl__y7x4qq(tmp$ret$0);
  }
  function _Vector___get_l__impl__envr1l($this) {
    return _Vector___get_values__impl__3gdbp5($this)[0];
  }
  function _Vector___get_m__impl__e5qq0m($this) {
    return _Vector___get_values__impl__3gdbp5($this)[1];
  }
  function _Vector___get_s__impl__pzuljk($this) {
    return _Vector___get_values__impl__3gdbp5($this)[2];
  }
  function dot_0(_this__u8e3s4, v0, v1, v2) {
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var p0 = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0) * v2;
    var p1 = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1) * v2;
    var p2 = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2) * v2;
    return _Vector___init__impl__y7x4qq_0(p0, p1, p2);
  }
  function dot$f($this_dot, $other, x, y) {
    return Matrix__get_impl_xogbpk($this_dot, 0, y) * Matrix__get_impl_xogbpk($other, x, 0) + Matrix__get_impl_xogbpk($this_dot, 1, y) * Matrix__get_impl_xogbpk($other, x, 1) + Matrix__get_impl_xogbpk($this_dot, 2, y) * Matrix__get_impl_xogbpk($other, x, 2);
  }
  function Companion() {
    Companion_instance = this;
    this.q1x_1 = componentInfoList([new ColorComponentInfo('code', false, 30.0, 107.0)]);
  }
  protoOf(Companion).r1x = function () {
    return this.q1x_1;
  };
  var Companion_instance;
  function Companion_getInstance() {
    if (Companion_instance == null)
      new Companion();
    return Companion_instance;
  }
  function Ansi16(code) {
    Companion_getInstance();
    this.s1x_1 = code;
  }
  protoOf(Ansi16).t1w = function () {
    return Companion_getInstance();
  };
  protoOf(Ansi16).u1w = function () {
    switch (this.s1x_1) {
      case 30:
      case 40:
        return Companion_getInstance_2().t1x(0.0, 0.0, 0.0);
      case 90:
      case 100:
        return Companion_getInstance_2().u1x(128, 128, 128);
      case 37:
      case 47:
        return Companion_getInstance_2().u1x(192, 192, 192);
      case 97:
      case 107:
        return Companion_getInstance_2().t1x(1.0, 1.0, 1.0);
    }
    var color = this.s1x_1 % 10 | 0;
    var mul = this.s1x_1 > 50 ? 1.0 : 0.5;
    var r = (color % 2 | 0) * mul;
    var g = ((color / 2 | 0) % 2 | 0) * mul;
    var b = ((color / 4 | 0) % 2 | 0) * mul;
    return Companion_getInstance_2().t1x(r, g, b);
  };
  protoOf(Ansi16).toString = function () {
    return 'Ansi16(code=' + this.s1x_1 + ')';
  };
  protoOf(Ansi16).hashCode = function () {
    return this.s1x_1;
  };
  protoOf(Ansi16).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Ansi16))
      return false;
    var tmp0_other_with_cast = other instanceof Ansi16 ? other : THROW_CCE();
    if (!(this.s1x_1 === tmp0_other_with_cast.s1x_1))
      return false;
    return true;
  };
  function Companion_0() {
    Companion_instance_0 = this;
    this.v1x_1 = componentInfoList([new ColorComponentInfo('code', false, 0.0, 255.0)]);
  }
  protoOf(Companion_0).r1x = function () {
    return this.v1x_1;
  };
  var Companion_instance_0;
  function Companion_getInstance_0() {
    if (Companion_instance_0 == null)
      new Companion_0();
    return Companion_instance_0;
  }
  function Ansi256(code) {
    Companion_getInstance_0();
    this.w1x_1 = code;
  }
  protoOf(Ansi256).t1w = function () {
    return Companion_getInstance_0();
  };
  protoOf(Ansi256).u1w = function () {
    if (this.w1x_1 < 16)
      return this.x1x().u1w();
    if (this.w1x_1 >= 232) {
      var c = imul(this.w1x_1 - 232 | 0, 10) + 8 | 0;
      return Companion_getInstance_2().u1x(c, c, c);
    }
    var c_0 = this.w1x_1 - 16 | 0;
    var rem = c_0 % 36 | 0;
    // Inline function 'kotlin.math.floor' call
    var x = c_0 / 36.0;
    var r = Math.floor(x) / 5.0;
    // Inline function 'kotlin.math.floor' call
    var x_0 = rem / 6.0;
    var g = Math.floor(x_0) / 5.0;
    var b = (rem % 6 | 0) / 5.0;
    return Companion_getInstance_2().y1x(r, g, b);
  };
  protoOf(Ansi256).x1x = function () {
    return this.w1x_1 < 8 ? new Ansi16(this.w1x_1 + 30 | 0) : this.w1x_1 < 16 ? new Ansi16((this.w1x_1 - 8 | 0) + 90 | 0) : this.u1w().x1x();
  };
  protoOf(Ansi256).toString = function () {
    return 'Ansi256(code=' + this.w1x_1 + ')';
  };
  protoOf(Ansi256).hashCode = function () {
    return this.w1x_1;
  };
  protoOf(Ansi256).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Ansi256))
      return false;
    var tmp0_other_with_cast = other instanceof Ansi256 ? other : THROW_CCE();
    if (!(this.w1x_1 === tmp0_other_with_cast.w1x_1))
      return false;
    return true;
  };
  function Companion_1() {
    Companion_instance_1 = this;
    this.z1x_1 = polarComponentInfo('HSV', 0.0, 1.0);
  }
  protoOf(Companion_1).r1x = function () {
    return this.z1x_1;
  };
  var Companion_instance_1;
  function Companion_getInstance_1() {
    if (Companion_instance_1 == null)
      new Companion_1();
    return Companion_instance_1;
  }
  function toSRGB$f(h, v, s, n) {
    var k = (n + h) % 6;
    var tmp = v * s;
    // Inline function 'kotlin.comparisons.minOf' call
    var b = 4 - k;
    var tmp$ret$0 = Math.min(k, b, 1.0);
    return v - tmp * coerceAtLeast(tmp$ret$0, 0.0);
  }
  function HSV(h, s, v, alpha) {
    Companion_getInstance_1();
    alpha = alpha === VOID ? 1.0 : alpha;
    this.a1y_1 = h;
    this.b1y_1 = s;
    this.c1y_1 = v;
    this.d1y_1 = alpha;
  }
  protoOf(HSV).t1w = function () {
    return Companion_getInstance_1();
  };
  protoOf(HSV).u1w = function () {
    if (this.b1y_1 < 1.0E-7)
      return Companion_getInstance_2().f1y(this.c1y_1, this.c1y_1, this.c1y_1, this.d1y_1);
    var v = this.c1y_1;
    var h = normalizeDeg_0(this.a1y_1) / 60.0;
    var s = this.b1y_1;
    return SRGB_getInstance().f1y(toSRGB$f(h, v, s, 5), toSRGB$f(h, v, s, 3), toSRGB$f(h, v, s, 1), this.d1y_1);
  };
  protoOf(HSV).toString = function () {
    return 'HSV(h=' + this.a1y_1 + ', s=' + this.b1y_1 + ', v=' + this.c1y_1 + ', alpha=' + this.d1y_1 + ')';
  };
  protoOf(HSV).hashCode = function () {
    var result = getNumberHashCode(this.a1y_1);
    result = imul(result, 31) + getNumberHashCode(this.b1y_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.c1y_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.d1y_1) | 0;
    return result;
  };
  protoOf(HSV).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof HSV))
      return false;
    var tmp0_other_with_cast = other instanceof HSV ? other : THROW_CCE();
    if (!equals(this.a1y_1, tmp0_other_with_cast.a1y_1))
      return false;
    if (!equals(this.b1y_1, tmp0_other_with_cast.b1y_1))
      return false;
    if (!equals(this.c1y_1, tmp0_other_with_cast.c1y_1))
      return false;
    if (!equals(this.d1y_1, tmp0_other_with_cast.d1y_1))
      return false;
    return true;
  };
  function get_ICTCP_RGB_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_RGB_TO_LMS;
  }
  var ICTCP_RGB_TO_LMS;
  function get_ICTCP_LMS_TO_ICTCP() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_LMS_TO_ICTCP;
  }
  var ICTCP_LMS_TO_ICTCP;
  function get_ICTCP_LMS_to_RGB() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_LMS_to_RGB;
  }
  var ICTCP_LMS_to_RGB;
  function get_ICTCP_ICTCP_to_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_ICTCP_to_LMS;
  }
  var ICTCP_ICTCP_to_LMS;
  function get_ICTCP_CROSSTALK() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_CROSSTALK;
  }
  var ICTCP_CROSSTALK;
  function get_HPE_XYZ_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return HPE_XYZ_TO_LMS;
  }
  var HPE_XYZ_TO_LMS;
  function get_ICTCP_XYZ_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_XYZ_TO_LMS;
  }
  var ICTCP_XYZ_TO_LMS;
  var ICTCP_LMS_TO_XYZ;
  function ICtCp() {
  }
  protoOf(ICtCp).l1y = function () {
    var fo = RGBColorSpaces_getInstance().t1y_1.y1y();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = get_ICTCP_ICTCP_to_LMS();
    var v0 = this.h1y_1;
    var v1 = this.i1y_1;
    var v2 = this.j1y_1;
    // Inline function 'com.github.ajalt.colormath.model.ICtCp.toBT2020.<anonymous>' call
    var l = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var m = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var s = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_1 = get_ICTCP_LMS_to_RGB();
    var v0_0 = PqNonlinearity_instance.h1z(l);
    var v1_0 = PqNonlinearity_instance.h1z(m);
    var v2_0 = PqNonlinearity_instance.h1z(s);
    // Inline function 'com.github.ajalt.colormath.model.ICtCp.toBT2020.<anonymous>.<anonymous>' call
    var r = Matrix__get_impl_xogbpk(this_1, 0, 0) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 0) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 0) * v2_0;
    var g = Matrix__get_impl_xogbpk(this_1, 0, 1) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 1) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 1) * v2_0;
    var b = Matrix__get_impl_xogbpk(this_1, 0, 2) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 2) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 2) * v2_0;
    return RGBColorSpaces_getInstance().t1y_1.f1y(fo.i1z(r), fo.i1z(g), fo.i1z(b), this.k1y_1);
  };
  function PqNonlinearity() {
    this.z1y_1 = 0.1593017578125;
    this.a1z_1 = 78.84375;
    this.b1z_1 = 0.8359375;
    this.c1z_1 = 18.8515625;
    this.d1z_1 = 18.6875;
    this.e1z_1 = 10000.0;
    this.f1z_1 = 6.277394636015326;
    this.g1z_1 = 0.012683313515655966;
  }
  protoOf(PqNonlinearity).h1z = function (x) {
    var vp = spow(x, 0.012683313515655966);
    var n = coerceAtLeast(vp - 0.8359375, 0.0);
    var l = spow_0(n / (18.8515625 - 18.6875 * vp), 6.277394636015326);
    return 10000.0 * l;
  };
  protoOf(PqNonlinearity).i1z = function (x) {
    var yp = spow_0(x / 10000.0, 0.1593017578125);
    return spow_0((0.8359375 + 18.8515625 * yp) / (1.0 + 18.6875 * yp), 78.84375);
  };
  var PqNonlinearity_instance;
  function PqNonlinearity_getInstance() {
    return PqNonlinearity_instance;
  }
  var properties_initialized_ICtCp_kt_w6y8uv;
  function _init_properties_ICtCp_kt__7vx7or() {
    if (!properties_initialized_ICtCp_kt_w6y8uv) {
      properties_initialized_ICtCp_kt_w6y8uv = true;
      ICTCP_RGB_TO_LMS = scalarDiv(_Matrix___init__impl__q3kp4w_0(1688.0, 2146.0, 262.0, 683.0, 2951.0, 462.0, 99.0, 309.0, 3688.0), 4096.0, true);
      ICTCP_LMS_TO_ICTCP = scalarDiv(_Matrix___init__impl__q3kp4w_0(2048.0, 2048.0, 0.0, 6610.0, -13613.0, 7003.0, 17933.0, -17390.0, -543.0), 4096.0, true);
      ICTCP_LMS_to_RGB = inverse(get_ICTCP_RGB_TO_LMS());
      ICTCP_ICTCP_to_LMS = inverse(get_ICTCP_LMS_TO_ICTCP());
      ICTCP_CROSSTALK = _Matrix___init__impl__q3kp4w_0(0.92, 0.04, 0.04, 0.04, 0.92, 0.04, 0.04, 0.04, 0.92);
      HPE_XYZ_TO_LMS = _Matrix___init__impl__q3kp4w_0(0.4002, 0.7076, -0.0808, -0.2263, 1.1653, 0.0457, 0.0, 0.0, 0.9182);
      ICTCP_XYZ_TO_LMS = dot(get_ICTCP_CROSSTALK(), get_HPE_XYZ_TO_LMS());
      ICTCP_LMS_TO_XYZ = inverse(get_ICTCP_XYZ_TO_LMS());
    }
  }
  function GammaTransferFunctions(gamma) {
    this.j1z_1 = gamma;
  }
  protoOf(GammaTransferFunctions).h1z = function (x) {
    return spow(x, this.j1z_1);
  };
  protoOf(GammaTransferFunctions).i1z = function (x) {
    return spow(x, 1.0 / this.j1z_1);
  };
  protoOf(GammaTransferFunctions).toString = function () {
    return 'GammaTransferFunctions(gamma=' + this.j1z_1 + ')';
  };
  protoOf(GammaTransferFunctions).hashCode = function () {
    return getNumberHashCode(this.j1z_1);
  };
  protoOf(GammaTransferFunctions).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof GammaTransferFunctions))
      return false;
    var tmp0_other_with_cast = other instanceof GammaTransferFunctions ? other : THROW_CCE();
    if (!equals(this.j1z_1, tmp0_other_with_cast.j1z_1))
      return false;
    return true;
  };
  function LinearTransferFunctions() {
  }
  protoOf(LinearTransferFunctions).h1z = function (x) {
    return x;
  };
  protoOf(LinearTransferFunctions).i1z = function (x) {
    return x;
  };
  var LinearTransferFunctions_instance;
  function LinearTransferFunctions_getInstance() {
    return LinearTransferFunctions_instance;
  }
  function RGBColorSpace() {
  }
  function Companion_2() {
    Companion_instance_2 = this;
    this.e1y_1 = RGBColorSpaces_getInstance().m1y_1;
  }
  protoOf(Companion_2).f1y = function (r, g, b, alpha) {
    return this.e1y_1.f1y(r, g, b, alpha);
  };
  protoOf(Companion_2).k1z = function (r, g, b, alpha) {
    return this.e1y_1.k1z(r, g, b, alpha);
  };
  protoOf(Companion_2).m1z = function (hex) {
    return this.e1y_1.m1z(hex);
  };
  protoOf(Companion_2).l1z = function (r, g, b, alpha) {
    return this.e1y_1.l1z(r, g, b, alpha);
  };
  protoOf(Companion_2).y1y = function () {
    return this.e1y_1.y1y();
  };
  protoOf(Companion_2).n1z = function () {
    return this.e1y_1.n1z();
  };
  protoOf(Companion_2).o1z = function () {
    return this.e1y_1.o1z();
  };
  protoOf(Companion_2).p1z = function () {
    return this.e1y_1.p1z();
  };
  protoOf(Companion_2).y13 = function () {
    return this.e1y_1.y13();
  };
  protoOf(Companion_2).r1x = function () {
    return this.e1y_1.r1x();
  };
  protoOf(Companion_2).equals = function (other) {
    return equals(RGBColorSpaces_getInstance().m1y_1, other);
  };
  protoOf(Companion_2).hashCode = function () {
    return hashCode(RGBColorSpaces_getInstance().m1y_1);
  };
  var Companion_instance_2;
  function Companion_getInstance_2() {
    if (Companion_instance_2 == null)
      new Companion_2();
    return Companion_instance_2;
  }
  function clamp$copy(receiver, p0, p1, p2, p3) {
    return receiver.q1z(p0, p1, p2, p3);
  }
  function RGB(r, g, b, alpha, space) {
    Companion_getInstance_2();
    this.w1w_1 = r;
    this.x1w_1 = g;
    this.y1w_1 = b;
    this.z1w_1 = alpha;
    this.a1x_1 = space;
  }
  protoOf(RGB).t1w = function () {
    return this.a1x_1;
  };
  protoOf(RGB).r1z = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.w1w_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).s1z = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.x1w_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).t1z = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.y1w_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).u1z = function (space) {
    var f = SRGB_getInstance().y1y();
    return equals(this.a1x_1, space) ? this : equals(this.a1x_1, SRGB_getInstance()) && equals(space, RGBColorSpaces_getInstance().n1y_1) ? space.f1y(f.h1z(this.w1w_1), f.h1z(this.x1w_1), f.h1z(this.y1w_1), this.z1w_1) : equals(this.a1x_1, RGBColorSpaces_getInstance().n1y_1) && equals(space, SRGB_getInstance()) ? space.f1y(f.i1z(this.w1w_1), f.i1z(this.x1w_1), f.i1z(this.y1w_1), this.z1w_1) : this.v1w().a20(space);
  };
  protoOf(RGB).b20 = function () {
    var tmp$ret$3;
    $l$block: {
      // Inline function 'com.github.ajalt.colormath.model.RGB.srgbHueMinMaxChroma' call
      // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
      var $this$toSRGB = this.u1z(SRGB_getInstance());
      var r = $this$toSRGB.w1w_1;
      var g = $this$toSRGB.x1w_1;
      var b = $this$toSRGB.y1w_1;
      // Inline function 'kotlin.comparisons.minOf' call
      var min = Math.min(r, g, b);
      // Inline function 'kotlin.comparisons.maxOf' call
      var max = Math.max(r, g, b);
      var chroma = max - min;
      var h = (chroma < 1.0E-7 ? NaN : r === max ? (g - b) / chroma : g === max ? 2 + (b - r) / chroma : b === max ? 4 + (r - g) / chroma : 0.0) * 60;
      // Inline function 'com.github.ajalt.colormath.model.RGB.toHSV.<anonymous>' call
      var h_0 = normalizeDeg(h);
      var s = max === 0.0 ? 0.0 : chroma / max;
      tmp$ret$3 = new HSV(h_0, s, max, this.z1w_1);
      break $l$block;
    }
    return tmp$ret$3;
  };
  protoOf(RGB).v1w = function () {
    var f = this.a1x_1.y1y();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = _Matrix___init__impl__q3kp4w(this.a1x_1.n1z());
    var v0 = f.h1z(this.w1w_1);
    var v1 = f.h1z(this.x1w_1);
    var v2 = f.h1z(this.y1w_1);
    // Inline function 'com.github.ajalt.colormath.model.RGB.toXYZ.<anonymous>' call
    var x = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var y = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var z = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    return XYZColorSpace_0(this.a1x_1.p1z()).f1y(x, y, z, this.z1w_1);
  };
  protoOf(RGB).x1x = function () {
    // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
    var $this$toSRGB = this.u1z(SRGB_getInstance());
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = $this$toSRGB.b20().c1y_1 * 100;
    var value = roundToInt(this_0);
    if (value === 30)
      return new Ansi16(30);
    var v = value / 50 | 0;
    // Inline function 'kotlin.math.roundToInt' call
    var this_1 = $this$toSRGB.y1w_1;
    var tmp$ret$1 = roundToInt(this_1);
    var tmp = imul(tmp$ret$1, 4);
    // Inline function 'kotlin.math.roundToInt' call
    var this_2 = $this$toSRGB.x1w_1;
    var tmp$ret$2 = roundToInt(this_2);
    var tmp_0 = tmp | imul(tmp$ret$2, 2);
    // Inline function 'kotlin.math.roundToInt' call
    var this_3 = $this$toSRGB.w1w_1;
    var ansi = 30 + (tmp_0 | roundToInt(this_3)) | 0;
    return new Ansi16(v === 2 ? ansi + 60 | 0 : ansi);
  };
  protoOf(RGB).c20 = function () {
    // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
    var $this$toSRGB = this.u1z(SRGB_getInstance());
    var ri = $this$toSRGB.r1z();
    var gi = $this$toSRGB.s1z();
    var bi = $this$toSRGB.t1z();
    var tmp;
    if (ri === gi && gi === bi) {
      tmp = ri < 8 ? 16 : ri > 248 ? 231 : roundToInt((ri - 8 | 0) / 247.0 * 24.0) + 232 | 0;
    } else {
      // Inline function 'kotlin.math.roundToInt' call
      var this_0 = $this$toSRGB.w1w_1 * 5;
      var tmp$ret$0 = roundToInt(this_0);
      var tmp_0 = 16 + imul(36, tmp$ret$0) | 0;
      // Inline function 'kotlin.math.roundToInt' call
      var this_1 = $this$toSRGB.x1w_1 * 5;
      var tmp$ret$1 = roundToInt(this_1);
      var tmp_1 = tmp_0 + imul(6, tmp$ret$1) | 0;
      // Inline function 'kotlin.math.roundToInt' call
      var this_2 = $this$toSRGB.y1w_1 * 5;
      tmp = tmp_1 + roundToInt(this_2) | 0;
    }
    var code = tmp;
    return new Ansi256(code);
  };
  protoOf(RGB).u1w = function () {
    return this.u1z(RGBColorSpaces_getInstance().m1y_1);
  };
  protoOf(RGB).d20 = function () {
    // Inline function 'com.github.ajalt.colormath.internal.clamp3' call
    var v1 = this.w1w_1;
    var v2 = this.x1w_1;
    var v3 = this.y1w_1;
    var alpha = this.z1w_1;
    var _destruct__k2r9zo = this.t1w().r1x();
    // Inline function 'kotlin.collections.component1' call
    var c1 = _destruct__k2r9zo.q(0);
    // Inline function 'kotlin.collections.component2' call
    var c2 = _destruct__k2r9zo.q(1);
    // Inline function 'kotlin.collections.component3' call
    var c3 = _destruct__k2r9zo.q(2);
    var tmp;
    var tmp_0;
    var tmp_1;
    var tmp_2;
    var containsLower = c1.d1x_1;
    if (v1 <= c1.e1x_1 ? containsLower <= v1 : false) {
      var containsLower_0 = c2.d1x_1;
      tmp_2 = v2 <= c2.e1x_1 ? containsLower_0 <= v2 : false;
    } else {
      tmp_2 = false;
    }
    if (tmp_2) {
      var containsLower_1 = c3.d1x_1;
      tmp_1 = v3 <= c3.e1x_1 ? containsLower_1 <= v3 : false;
    } else {
      tmp_1 = false;
    }
    if (tmp_1) {
      tmp_0 = 0.0 <= alpha ? alpha <= 1.0 : false;
    } else {
      tmp_0 = false;
    }
    if (tmp_0) {
      tmp = this;
    } else {
      tmp = clamp$copy(this, coerceIn(v1, c1.d1x_1, c1.e1x_1), coerceIn(v2, c2.d1x_1, c2.e1x_1), coerceIn(v3, c3.d1x_1, c3.e1x_1), coerceIn(alpha, 0.0, 1.0));
    }
    return tmp;
  };
  protoOf(RGB).e20 = function (r, g, b, alpha, space) {
    return new RGB(r, g, b, alpha, space);
  };
  protoOf(RGB).q1z = function (r, g, b, alpha, space, $super) {
    r = r === VOID ? this.w1w_1 : r;
    g = g === VOID ? this.x1w_1 : g;
    b = b === VOID ? this.y1w_1 : b;
    alpha = alpha === VOID ? this.z1w_1 : alpha;
    space = space === VOID ? this.a1x_1 : space;
    return $super === VOID ? this.e20(r, g, b, alpha, space) : $super.e20.call(this, r, g, b, alpha, space);
  };
  protoOf(RGB).toString = function () {
    return 'RGB(r=' + this.w1w_1 + ', g=' + this.x1w_1 + ', b=' + this.y1w_1 + ', alpha=' + this.z1w_1 + ', space=' + toString(this.a1x_1) + ')';
  };
  protoOf(RGB).hashCode = function () {
    var result = getNumberHashCode(this.w1w_1);
    result = imul(result, 31) + getNumberHashCode(this.x1w_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.y1w_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.z1w_1) | 0;
    result = imul(result, 31) + hashCode(this.a1x_1) | 0;
    return result;
  };
  protoOf(RGB).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof RGB))
      return false;
    var tmp0_other_with_cast = other instanceof RGB ? other : THROW_CCE();
    if (!equals(this.w1w_1, tmp0_other_with_cast.w1w_1))
      return false;
    if (!equals(this.x1w_1, tmp0_other_with_cast.x1w_1))
      return false;
    if (!equals(this.y1w_1, tmp0_other_with_cast.y1w_1))
      return false;
    if (!equals(this.z1w_1, tmp0_other_with_cast.z1w_1))
      return false;
    if (!equals(this.a1x_1, tmp0_other_with_cast.a1x_1))
      return false;
    return true;
  };
  function parseHex(_this__u8e3s4, startIndex) {
    var tmp;
    if (get_hexLength(_this__u8e3s4) > 4) {
      var i = charSequenceGet(_this__u8e3s4, 0) === _Char___init__impl__6a9atx(35) ? imul(startIndex, 2) + 1 | 0 : imul(startIndex, 2);
      tmp = toInt(slice(_this__u8e3s4, numberRangeToNumber(i, i + 1 | 0)), 16);
    } else {
      var i_0 = charSequenceGet(_this__u8e3s4, 0) === _Char___init__impl__6a9atx(35) ? startIndex + 1 | 0 : startIndex;
      // Inline function 'kotlin.let' call
      // Inline function 'kotlin.contracts.contract' call
      // Inline function 'com.github.ajalt.colormath.model.parseHex.<anonymous>' call
      var it = charSequenceGet(_this__u8e3s4, i_0);
      var tmp$ret$1 = toString_0(it) + toString_0(it);
      tmp = toInt(tmp$ret$1, 16);
    }
    return tmp;
  }
  function validateHex(_this__u8e3s4) {
    // Inline function 'kotlin.apply' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>' call
    // Inline function 'kotlin.require' call
    // Inline function 'kotlin.let' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>.<anonymous>' call
    var it = get_hexLength(_this__u8e3s4);
    switch (it) {
      case 3:
      case 4:
      case 6:
        var tmp$ret$0 = true;
        break;
      default:
        tmp$ret$0 = it === 8;
        break;
    }
    // Inline function 'kotlin.contracts.contract' call
    if (!tmp$ret$0) {
      // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>.<anonymous>' call
      var message = 'Hex string must be in the format "#ffffff" or "ffffff"';
      throw IllegalArgumentException_init_$Create$(toString(message));
    }
    return _this__u8e3s4;
  }
  function get_hexLength(_this__u8e3s4) {
    return startsWith(_this__u8e3s4, '#') ? _this__u8e3s4.length - 1 | 0 : _this__u8e3s4.length;
  }
  function get_SRGB_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_R;
  }
  var SRGB_R;
  function get_SRGB_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_G;
  }
  var SRGB_G;
  function get_SRGB_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_B;
  }
  var SRGB_B;
  function get_ACES_WHITE_POINT() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_WHITE_POINT;
  }
  var ACES_WHITE_POINT;
  function get_ACES_AP0_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_R;
  }
  var ACES_AP0_R;
  function get_ACES_AP0_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_G;
  }
  var ACES_AP0_G;
  function get_ACES_AP0_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_B;
  }
  var ACES_AP0_B;
  function get_ACES_AP1_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_R;
  }
  var ACES_AP1_R;
  function get_ACES_AP1_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_G;
  }
  var ACES_AP1_G;
  function get_ACES_AP1_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_B;
  }
  var ACES_AP1_B;
  function RGBColorSpaces$SRGB$lambda($this$RGBColorSpaceImpl, it) {
    return it.u1w();
  }
  function RGBColorSpaces$BT2020$lambda($this$RGBColorSpaceImpl, color) {
    var tmp;
    if (color instanceof RGB) {
      tmp = color.u1z($this$RGBColorSpaceImpl);
    } else {
      if (color instanceof ICtCp) {
        tmp = color.l1y();
      } else {
        tmp = color.v1w().a20($this$RGBColorSpaceImpl);
      }
    }
    return tmp;
  }
  function RGBColorSpaces() {
    RGBColorSpaces_instance = this;
    var tmp = this;
    var tmp_0 = Illuminant_getInstance().m1x_1;
    var tmp_1 = SRGBTransferFunctions_instance;
    var tmp_2 = get_SRGB_R();
    var tmp_3 = get_SRGB_G();
    var tmp_4 = get_SRGB_B();
    tmp.m1y_1 = new RGBColorSpaceImpl('sRGB', tmp_0, tmp_1, tmp_2, tmp_3, tmp_4, RGBColorSpaces$SRGB$lambda);
    this.n1y_1 = RGBColorSpace_0('Linear sRGB', Illuminant_getInstance().m1x_1, LinearTransferFunctions_instance, get_SRGB_R(), get_SRGB_G(), get_SRGB_B());
    this.o1y_1 = RGBColorSpace_0('ACES2065-1', get_ACES_WHITE_POINT(), LinearTransferFunctions_instance, get_ACES_AP0_R(), get_ACES_AP0_G(), get_ACES_AP0_B());
    this.p1y_1 = RGBColorSpace_0('ACEScc', get_ACES_WHITE_POINT(), ACESccTransferFunctions_getInstance(), get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.q1y_1 = RGBColorSpace_0('ACEScct', get_ACES_WHITE_POINT(), ACEScctTransferFunctions_getInstance(), get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.r1y_1 = RGBColorSpace_0('ACEScg', get_ACES_WHITE_POINT(), LinearTransferFunctions_instance, get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.s1y_1 = RGBColorSpace_0('Adobe RGB', Illuminant_getInstance().m1x_1, new GammaTransferFunctions(2.19921875), xyY_init_$Create$(0.64, 0.33), xyY_init_$Create$(0.21, 0.71), xyY_init_$Create$(0.15, 0.06));
    var tmp_5 = this;
    var tmp_6 = Illuminant_getInstance().m1x_1;
    var tmp_7 = BT2020TransferFunctions_getInstance();
    var tmp_8 = xyY_init_$Create$(0.708, 0.292);
    var tmp_9 = xyY_init_$Create$(0.17, 0.797);
    var tmp_10 = xyY_init_$Create$(0.131, 0.046);
    tmp_5.t1y_1 = new RGBColorSpaceImpl('BT.2020', tmp_6, tmp_7, tmp_8, tmp_9, tmp_10, RGBColorSpaces$BT2020$lambda);
    this.u1y_1 = RGBColorSpace_0('BT.709', Illuminant_getInstance().m1x_1, BT709TransferFunctions_getInstance(), xyY_init_$Create$(0.64, 0.33), xyY_init_$Create$(0.3, 0.6), xyY_init_$Create$(0.15, 0.06));
    this.v1y_1 = RGBColorSpace_0('DCI P3', new WhitePoint('DCI P3', xyY_init_$Create$(0.314, 0.351)), new GammaTransferFunctions(2.6), xyY_init_$Create$(0.68, 0.32), xyY_init_$Create$(0.265, 0.69), xyY_init_$Create$(0.15, 0.06));
    this.w1y_1 = RGBColorSpace_0('Display P3', Illuminant_getInstance().m1x_1, SRGBTransferFunctions_instance, xyY_init_$Create$(0.68, 0.32), xyY_init_$Create$(0.265, 0.69), xyY_init_$Create$(0.15, 0.06));
    this.x1y_1 = RGBColorSpace_0('ROMM RGB', Illuminant_getInstance().k1x_1, ROMMTransferFunctions_instance, xyY_init_$Create$(0.7347, 0.2653), xyY_init_$Create$(0.1596, 0.8404), xyY_init_$Create$(0.0366, 1.0E-4));
  }
  var RGBColorSpaces_instance;
  function RGBColorSpaces_getInstance() {
    if (RGBColorSpaces_instance == null)
      new RGBColorSpaces();
    return RGBColorSpaces_instance;
  }
  function SRGB() {
    SRGB_instance = this;
    this.g1y_1 = RGBColorSpaces_getInstance().m1y_1;
  }
  protoOf(SRGB).f1y = function (r, g, b, alpha) {
    return this.g1y_1.f1y(r, g, b, alpha);
  };
  protoOf(SRGB).k1z = function (r, g, b, alpha) {
    return this.g1y_1.k1z(r, g, b, alpha);
  };
  protoOf(SRGB).m1z = function (hex) {
    return this.g1y_1.m1z(hex);
  };
  protoOf(SRGB).l1z = function (r, g, b, alpha) {
    return this.g1y_1.l1z(r, g, b, alpha);
  };
  protoOf(SRGB).y1y = function () {
    return this.g1y_1.y1y();
  };
  protoOf(SRGB).n1z = function () {
    return this.g1y_1.n1z();
  };
  protoOf(SRGB).o1z = function () {
    return this.g1y_1.o1z();
  };
  protoOf(SRGB).p1z = function () {
    return this.g1y_1.p1z();
  };
  protoOf(SRGB).y13 = function () {
    return this.g1y_1.y13();
  };
  protoOf(SRGB).r1x = function () {
    return this.g1y_1.r1x();
  };
  protoOf(SRGB).equals = function (other) {
    return equals(RGBColorSpaces_getInstance().m1y_1, other);
  };
  protoOf(SRGB).hashCode = function () {
    return hashCode(RGBColorSpaces_getInstance().m1y_1);
  };
  protoOf(SRGB).toString = function () {
    return 'sRGB';
  };
  var SRGB_instance;
  function SRGB_getInstance() {
    if (SRGB_instance == null)
      new SRGB();
    return SRGB_instance;
  }
  function RGBColorSpaceImpl(name, whitePoint, transferFunctions, r, g, b, convertImpl) {
    this.f20_1 = name;
    this.g20_1 = whitePoint;
    this.h20_1 = transferFunctions;
    this.i20_1 = r;
    this.j20_1 = g;
    this.k20_1 = b;
    this.l20_1 = convertImpl;
    this.m20_1 = zeroOneComponentInfo('RGB');
    this.n20_1 = _Matrix___get_rowMajor__impl__vmgxkq(rgbToXyzMatrix(this.g20_1, this.i20_1, this.j20_1, this.k20_1));
    this.o20_1 = _Matrix___get_rowMajor__impl__vmgxkq(inverse(_Matrix___init__impl__q3kp4w(this.n20_1)));
  }
  protoOf(RGBColorSpaceImpl).y13 = function () {
    return this.f20_1;
  };
  protoOf(RGBColorSpaceImpl).p1z = function () {
    return this.g20_1;
  };
  protoOf(RGBColorSpaceImpl).y1y = function () {
    return this.h20_1;
  };
  protoOf(RGBColorSpaceImpl).r1x = function () {
    return this.m20_1;
  };
  protoOf(RGBColorSpaceImpl).n1z = function () {
    return this.n20_1;
  };
  protoOf(RGBColorSpaceImpl).o1z = function () {
    return this.o20_1;
  };
  protoOf(RGBColorSpaceImpl).toString = function () {
    return this.f20_1;
  };
  protoOf(RGBColorSpaceImpl).f1y = function (r, g, b, alpha) {
    return new RGB(r, g, b, alpha, this);
  };
  protoOf(RGBColorSpaceImpl).equals = function (other) {
    if (this === other)
      return true;
    if (!(!(other == null) ? isInterface(other, RGBColorSpace) : false))
      return false;
    if (!(this.f20_1 === other.y13()))
      return false;
    if (!this.g20_1.equals(other.p1z()))
      return false;
    if (!equals(this.h20_1, other.y1y()))
      return false;
    if (other instanceof RGBColorSpaceImpl) {
      if (!this.i20_1.equals(other.i20_1))
        return false;
      if (!this.j20_1.equals(other.j20_1))
        return false;
      if (!this.k20_1.equals(other.k20_1))
        return false;
    } else {
      if (!contentEquals(this.n20_1, other.n1z()))
        return false;
      if (!contentEquals(this.o20_1, other.o1z()))
        return false;
    }
    return true;
  };
  protoOf(RGBColorSpaceImpl).hashCode = function () {
    var result = getStringHashCode(this.f20_1);
    result = imul(31, result) + this.g20_1.hashCode() | 0;
    result = imul(31, result) + hashCode(this.h20_1) | 0;
    result = imul(31, result) + this.i20_1.hashCode() | 0;
    result = imul(31, result) + this.j20_1.hashCode() | 0;
    result = imul(31, result) + this.k20_1.hashCode() | 0;
    return result;
  };
  function SRGBTransferFunctions() {
  }
  protoOf(SRGBTransferFunctions).i1z = function (x) {
    return x <= 0.0031308 ? x * 12.92 : 1.055 * spow(x, 1 / 2.4) - 0.055;
  };
  protoOf(SRGBTransferFunctions).h1z = function (x) {
    return x <= 0.04045 ? x / 12.92 : spow_0((x + 0.055) / 1.055, 2.4);
  };
  var SRGBTransferFunctions_instance;
  function SRGBTransferFunctions_getInstance() {
    return SRGBTransferFunctions_instance;
  }
  function RGBColorSpace_0(name, whitePoint, transferFunctions, r, g, b) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return new RGBColorSpaceImpl(name, whitePoint, transferFunctions, r, g, b, RGBColorSpace$lambda);
  }
  function ACESccTransferFunctions() {
    ACESccTransferFunctions_instance = this;
    this.p20_1 = 3.0517578125E-5;
    this.q20_1 = 1.52587890625E-5;
    this.r20_1 = -0.3013698630136986;
    var tmp = this;
    // Inline function 'kotlin.math.log2' call
    tmp.s20_1 = (log2(65504.0) + 9.72) / 17.52;
  }
  protoOf(ACESccTransferFunctions).h1z = function (x) {
    var tmp;
    if (x <= -0.3013698630136986) {
      tmp = (spow_0(2.0, x * 17.52 - 9.72) - 1.52587890625E-5) * 2.0;
    } else if (x < this.s20_1) {
      // Inline function 'kotlin.math.pow' call
      var x_0 = x * 17.52 - 9.72;
      tmp = Math.pow(2.0, x_0);
    } else {
      tmp = 65504.0;
    }
    return tmp;
  };
  protoOf(ACESccTransferFunctions).i1z = function (x) {
    var tmp;
    if (x < 3.0517578125E-5) {
      // Inline function 'kotlin.math.log2' call
      var x_0 = 1.52587890625E-5 + coerceAtLeast_0(x, 0.0) / 2.0;
      tmp = (log2(x_0) + 9.72) / 17.52;
    } else {
      // Inline function 'kotlin.math.log2' call
      tmp = (log2(x) + 9.72) / 17.52;
    }
    return tmp;
  };
  var ACESccTransferFunctions_instance;
  function ACESccTransferFunctions_getInstance() {
    if (ACESccTransferFunctions_instance == null)
      new ACESccTransferFunctions();
    return ACESccTransferFunctions_instance;
  }
  function ACEScctTransferFunctions() {
    ACEScctTransferFunctions_instance = this;
    this.t20_1 = 10.5402377416545;
    this.u20_1 = 0.0729055341958355;
    var tmp = this;
    // Inline function 'kotlin.math.log2' call
    tmp.v20_1 = (log2(65504.0) + 9.72) / 17.52;
  }
  protoOf(ACEScctTransferFunctions).h1z = function (x) {
    var tmp;
    if (x <= 0.155251141552511) {
      tmp = (x - 0.0729055341958355) / 10.5402377416545;
    } else if (x < this.v20_1) {
      // Inline function 'kotlin.math.pow' call
      var x_0 = x * 17.52 - 9.72;
      tmp = Math.pow(2.0, x_0);
    } else {
      tmp = 65504.0;
    }
    return tmp;
  };
  protoOf(ACEScctTransferFunctions).i1z = function (x) {
    var tmp;
    if (x < 0.0078125) {
      tmp = 10.5402377416545 * x + 0.0729055341958355;
    } else {
      // Inline function 'kotlin.math.log2' call
      tmp = (log2(x) + 9.72) / 17.52;
    }
    return tmp;
  };
  var ACEScctTransferFunctions_instance;
  function ACEScctTransferFunctions_getInstance() {
    if (ACEScctTransferFunctions_instance == null)
      new ACEScctTransferFunctions();
    return ACEScctTransferFunctions_instance;
  }
  function BT2020TransferFunctions() {
    BT2020TransferFunctions_instance = this;
    this.w20_1 = 1.0993;
    this.x20_1 = 0.0181;
    var tmp = this;
    // Inline function 'kotlin.math.pow' call
    tmp.y20_1 = 1.0993 * Math.pow(0.0181, 0.45) - (1.0993 - 1);
  }
  protoOf(BT2020TransferFunctions).h1z = function (x) {
    return numberToDouble(x < this.y20_1 ? x / 4.5 : spow_0((x + (1.0993 - 1)) / 1.0993, 1 / 0.45));
  };
  protoOf(BT2020TransferFunctions).i1z = function (x) {
    return x < 0.0181 ? 4.5 * x : 1.0993 * spow(x, 0.45) - (1.0993 - 1);
  };
  var BT2020TransferFunctions_instance;
  function BT2020TransferFunctions_getInstance() {
    if (BT2020TransferFunctions_instance == null)
      new BT2020TransferFunctions();
    return BT2020TransferFunctions_instance;
  }
  function BT709TransferFunctions() {
    BT709TransferFunctions_instance = this;
    this.z20_1 = 1.099 * spow_0(0.018, 0.45) - 0.099;
  }
  protoOf(BT709TransferFunctions).h1z = function (x) {
    return numberToDouble(x < this.z20_1 ? x / 4.5 : spow_0((x + 0.099) / 1.099, 1 / 0.45));
  };
  protoOf(BT709TransferFunctions).i1z = function (x) {
    return x < 0.018 ? 4.5 * x : 1.099 * spow(x, 0.45) - 0.099;
  };
  var BT709TransferFunctions_instance;
  function BT709TransferFunctions_getInstance() {
    if (BT709TransferFunctions_instance == null)
      new BT709TransferFunctions();
    return BT709TransferFunctions_instance;
  }
  function ROMMTransferFunctions() {
    this.a21_1 = 0.001953;
  }
  protoOf(ROMMTransferFunctions).h1z = function (x) {
    return x < 16 * 0.001953 ? x / 16.0 : spow(x, 1.8);
  };
  protoOf(ROMMTransferFunctions).i1z = function (x) {
    return x < 0.001953 ? x * 16.0 : spow(x, 1.0 / 1.8);
  };
  var ROMMTransferFunctions_instance;
  function ROMMTransferFunctions_getInstance() {
    return ROMMTransferFunctions_instance;
  }
  function rgbToXyzMatrix(whitePoint, r, g, b) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    var primaries = _Matrix___init__impl__q3kp4w_0(r.b21_1, g.b21_1, b.b21_1, r.c21_1, g.c21_1, b.c21_1, r.e21(), g.e21(), b.e21());
    var wp = whitePoint.g1x_1;
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = inverse(primaries);
    var v0 = wp.f21();
    var v1 = wp.d21_1;
    var v2 = wp.g21();
    // Inline function 'com.github.ajalt.colormath.model.rgbToXyzMatrix.<anonymous>' call
    var x = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var y = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var z = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    return dotDiagonal(primaries, x, y, z);
  }
  function RGBColorSpace$lambda($this$RGBColorSpaceImpl, color) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    var tmp;
    if (color instanceof RGB) {
      tmp = color.u1z($this$RGBColorSpaceImpl);
    } else {
      tmp = color.v1w().a20($this$RGBColorSpaceImpl);
    }
    return tmp;
  }
  var properties_initialized_RGBColorSpaces_kt_fsnpad;
  function _init_properties_RGBColorSpaces_kt__nc9fsz() {
    if (!properties_initialized_RGBColorSpaces_kt_fsnpad) {
      properties_initialized_RGBColorSpaces_kt_fsnpad = true;
      SRGB_R = xyY_init_$Create$(0.64, 0.33);
      SRGB_G = xyY_init_$Create$(0.3, 0.6);
      SRGB_B = xyY_init_$Create$(0.15, 0.06);
      ACES_WHITE_POINT = new WhitePoint('ACES', xyY_init_$Create$(0.32168, 0.33767));
      ACES_AP0_R = xyY_init_$Create$(0.7347, 0.2653);
      ACES_AP0_G = xyY_init_$Create$(0.0, 1.0);
      ACES_AP0_B = xyY_init_$Create$(1.0E-4, -0.077);
      ACES_AP1_R = xyY_init_$Create$(0.713, 0.293);
      ACES_AP1_G = xyY_init_$Create$(0.165, 0.83);
      ACES_AP1_B = xyY_init_$Create$(0.128, 0.044);
    }
  }
  function Companion_3() {
    Companion_instance_3 = this;
    this.h21_1 = XYZColorSpaces_getInstance().i21_1;
  }
  protoOf(Companion_3).f1y = function (x, y, z, alpha) {
    return this.h21_1.f1y(x, y, z, alpha);
  };
  protoOf(Companion_3).p1z = function () {
    return this.h21_1.p1z();
  };
  protoOf(Companion_3).r1x = function () {
    return this.h21_1.r1x();
  };
  protoOf(Companion_3).hashCode = function () {
    return hashCode(XYZColorSpaces_getInstance().i21_1);
  };
  protoOf(Companion_3).equals = function (other) {
    return equals(XYZColorSpaces_getInstance().i21_1, other);
  };
  var Companion_instance_3;
  function Companion_getInstance_3() {
    if (Companion_instance_3 == null)
      new Companion_3();
    return Companion_instance_3;
  }
  function adaptToM($this, space, m, mi) {
    if (space.p1z().equals($this.z1z_1.p1z()))
      return $this;
    var transform = chromaticAdaptationMatrix(space, $this.z1z_1.p1z().g1x_1, m, mi);
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var v0 = $this.v1z_1;
    var v1 = $this.w1z_1;
    var v2 = $this.x1z_1;
    // Inline function 'com.github.ajalt.colormath.model.XYZ.adaptToM.<anonymous>' call
    var xx = Matrix__get_impl_xogbpk(transform, 0, 0) * v0 + Matrix__get_impl_xogbpk(transform, 1, 0) * v1 + Matrix__get_impl_xogbpk(transform, 2, 0) * v2;
    var yy = Matrix__get_impl_xogbpk(transform, 0, 1) * v0 + Matrix__get_impl_xogbpk(transform, 1, 1) * v1 + Matrix__get_impl_xogbpk(transform, 2, 1) * v2;
    var zz = Matrix__get_impl_xogbpk(transform, 0, 2) * v0 + Matrix__get_impl_xogbpk(transform, 1, 2) * v1 + Matrix__get_impl_xogbpk(transform, 2, 2) * v2;
    return space.f1y(xx, yy, zz, $this.y1z_1);
  }
  function XYZ(x, y, z, alpha, space) {
    Companion_getInstance_3();
    this.v1z_1 = x;
    this.w1z_1 = y;
    this.x1z_1 = z;
    this.y1z_1 = alpha;
    this.z1z_1 = space;
  }
  protoOf(XYZ).t1w = function () {
    return this.z1z_1;
  };
  protoOf(XYZ).k21 = function (space) {
    return adaptToM(this, space, get_CAT02_XYZ_TO_LMS(), get_CAT02_LMS_TO_XYZ());
  };
  protoOf(XYZ).a20 = function (space) {
    var _destruct__k2r9zo = this.k21(XYZColorSpace_0(space.p1z()));
    var x = _destruct__k2r9zo.aa();
    var y = _destruct__k2r9zo.ba();
    var z = _destruct__k2r9zo.jh();
    var f = space.y1y();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = _Matrix___init__impl__q3kp4w(space.o1z());
    // Inline function 'com.github.ajalt.colormath.model.XYZ.toRGB.<anonymous>' call
    var r = Matrix__get_impl_xogbpk(this_0, 0, 0) * x + Matrix__get_impl_xogbpk(this_0, 1, 0) * y + Matrix__get_impl_xogbpk(this_0, 2, 0) * z;
    var g = Matrix__get_impl_xogbpk(this_0, 0, 1) * x + Matrix__get_impl_xogbpk(this_0, 1, 1) * y + Matrix__get_impl_xogbpk(this_0, 2, 1) * z;
    var b = Matrix__get_impl_xogbpk(this_0, 0, 2) * x + Matrix__get_impl_xogbpk(this_0, 1, 2) * y + Matrix__get_impl_xogbpk(this_0, 2, 2) * z;
    return space.f1y(f.i1z(r), f.i1z(g), f.i1z(b), this.y1z_1);
  };
  protoOf(XYZ).u1w = function () {
    return this.a20(RGBColorSpaces_getInstance().m1y_1);
  };
  protoOf(XYZ).v1w = function () {
    return this;
  };
  protoOf(XYZ).aa = function () {
    return this.v1z_1;
  };
  protoOf(XYZ).ba = function () {
    return this.w1z_1;
  };
  protoOf(XYZ).jh = function () {
    return this.x1z_1;
  };
  protoOf(XYZ).toString = function () {
    return 'XYZ(x=' + this.v1z_1 + ', y=' + this.w1z_1 + ', z=' + this.x1z_1 + ', alpha=' + this.y1z_1 + ', space=' + toString(this.z1z_1) + ')';
  };
  protoOf(XYZ).hashCode = function () {
    var result = getNumberHashCode(this.v1z_1);
    result = imul(result, 31) + getNumberHashCode(this.w1z_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.x1z_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.y1z_1) | 0;
    result = imul(result, 31) + hashCode(this.z1z_1) | 0;
    return result;
  };
  protoOf(XYZ).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof XYZ))
      return false;
    var tmp0_other_with_cast = other instanceof XYZ ? other : THROW_CCE();
    if (!equals(this.v1z_1, tmp0_other_with_cast.v1z_1))
      return false;
    if (!equals(this.w1z_1, tmp0_other_with_cast.w1z_1))
      return false;
    if (!equals(this.x1z_1, tmp0_other_with_cast.x1z_1))
      return false;
    if (!equals(this.y1z_1, tmp0_other_with_cast.y1z_1))
      return false;
    if (!equals(this.z1z_1, tmp0_other_with_cast.z1z_1))
      return false;
    return true;
  };
  function XYZColorSpace() {
  }
  function XYZColorSpace_0(whitePoint) {
    return whitePoint.equals(Illuminant_getInstance().m1x_1) ? XYZColorSpaces_getInstance().i21_1 : whitePoint.equals(Illuminant_getInstance().k1x_1) ? XYZColorSpaces_getInstance().j21_1 : new XYZColorSpaceImpl(whitePoint);
  }
  function XYZColorSpaces() {
    XYZColorSpaces_instance = this;
    this.i21_1 = new XYZColorSpaceImpl(Illuminant_getInstance().m1x_1);
    this.j21_1 = new XYZColorSpaceImpl(Illuminant_getInstance().k1x_1);
  }
  var XYZColorSpaces_instance;
  function XYZColorSpaces_getInstance() {
    if (XYZColorSpaces_instance == null)
      new XYZColorSpaces();
    return XYZColorSpaces_instance;
  }
  function chromaticAdaptationMatrix(_this__u8e3s4, srcWp, xyzToLms, lmsToXyz) {
    xyzToLms = xyzToLms === VOID ? get_CAT02_XYZ_TO_LMS() : xyzToLms;
    lmsToXyz = lmsToXyz === VOID ? get_CAT02_LMS_TO_XYZ() : lmsToXyz;
    var dstWp = _this__u8e3s4.p1z().g1x_1;
    var src = dot_0(xyzToLms, srcWp.f21(), srcWp.d21_1, srcWp.g21());
    var dst = dot_0(xyzToLms, dstWp.f21(), dstWp.d21_1, dstWp.g21());
    return dot(dotDiagonal(lmsToXyz, _Vector___get_l__impl__envr1l(dst) / _Vector___get_l__impl__envr1l(src), _Vector___get_m__impl__e5qq0m(dst) / _Vector___get_m__impl__e5qq0m(src), _Vector___get_s__impl__pzuljk(dst) / _Vector___get_s__impl__pzuljk(src)), xyzToLms);
  }
  function XYZColorSpaceImpl(whitePoint) {
    this.l21_1 = whitePoint;
    this.m21_1 = zeroOneComponentInfo('XYZ');
  }
  protoOf(XYZColorSpaceImpl).p1z = function () {
    return this.l21_1;
  };
  protoOf(XYZColorSpaceImpl).r1x = function () {
    return this.m21_1;
  };
  protoOf(XYZColorSpaceImpl).toString = function () {
    return 'XYZColorSpace(' + this.l21_1.toString() + ')';
  };
  protoOf(XYZColorSpaceImpl).f1y = function (x, y, z, alpha) {
    return new XYZ(x, y, z, alpha, this);
  };
  protoOf(XYZColorSpaceImpl).hashCode = function () {
    return this.l21_1.hashCode();
  };
  protoOf(XYZColorSpaceImpl).equals = function (other) {
    var tmp;
    if (!(other == null) ? isInterface(other, XYZColorSpace) : false) {
      tmp = this.l21_1.equals(other.p1z());
    } else {
      tmp = false;
    }
    return tmp;
  };
  function xyY_init_$Init$(x, y, Y, $this) {
    Y = Y === VOID ? 1.0 : Y;
    xyY.call($this, numberToDouble(x), numberToDouble(y), numberToDouble(Y));
    return $this;
  }
  function xyY_init_$Create$(x, y, Y) {
    return xyY_init_$Init$(x, y, Y, objectCreate(protoOf(xyY)));
  }
  function xyY(x, y, Y) {
    Y = Y === VOID ? 1.0 : Y;
    this.b21_1 = x;
    this.c21_1 = y;
    this.d21_1 = Y;
  }
  protoOf(xyY).e21 = function () {
    return 1 - this.b21_1 - this.c21_1;
  };
  protoOf(xyY).f21 = function () {
    return this.b21_1 * this.d21_1 / this.c21_1;
  };
  protoOf(xyY).g21 = function () {
    return (1 - this.b21_1 - this.c21_1) * this.d21_1 / this.c21_1;
  };
  protoOf(xyY).toString = function () {
    return 'xyY(x=' + this.b21_1 + ', y=' + this.c21_1 + ', Y=' + this.d21_1 + ')';
  };
  protoOf(xyY).hashCode = function () {
    var result = getNumberHashCode(this.b21_1);
    result = imul(result, 31) + getNumberHashCode(this.c21_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.d21_1) | 0;
    return result;
  };
  protoOf(xyY).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof xyY))
      return false;
    var tmp0_other_with_cast = other instanceof xyY ? other : THROW_CCE();
    if (!equals(this.b21_1, tmp0_other_with_cast.b21_1))
      return false;
    if (!equals(this.c21_1, tmp0_other_with_cast.c21_1))
      return false;
    if (!equals(this.d21_1, tmp0_other_with_cast.d21_1))
      return false;
    return true;
  };
  //region block: post-declaration
  protoOf(Ansi16).v1w = toXYZ;
  protoOf(Ansi256).v1w = toXYZ;
  protoOf(HSV).v1w = toXYZ;
  protoOf(Companion_2).t1x = invoke$default;
  protoOf(Companion_2).y1x = invoke$default_0;
  protoOf(Companion_2).u1x = from255$default;
  protoOf(SRGB).t1x = invoke$default;
  protoOf(SRGB).y1x = invoke$default_0;
  protoOf(SRGB).u1x = from255$default;
  protoOf(RGBColorSpaceImpl).t1x = invoke$default;
  protoOf(RGBColorSpaceImpl).k1z = invoke;
  protoOf(RGBColorSpaceImpl).y1x = invoke$default_0;
  protoOf(RGBColorSpaceImpl).m1z = invoke_0;
  protoOf(RGBColorSpaceImpl).l1z = from255;
  protoOf(RGBColorSpaceImpl).u1x = from255$default;
  //endregion
  //region block: init
  PqNonlinearity_instance = new PqNonlinearity();
  LinearTransferFunctions_instance = new LinearTransferFunctions();
  SRGBTransferFunctions_instance = new SRGBTransferFunctions();
  ROMMTransferFunctions_instance = new ROMMTransferFunctions();
  //endregion
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = Ansi16;
  _.$_$.b = Ansi256;
  _.$_$.c = Companion_getInstance_2;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js')));

//# sourceMappingURL=colormath-root-colormath.js.map
